/*
 * @description: 
 * @Author: CP
 * @Date: 2020-12-28 14:41:49
 * @FilePath: \cld\global\gridManager\fee\incomeCollect.js
 */

// 表格唯一标识
const gridManagerName = 'test';


const demo1 = {
    /**
     * 初始化搜索区域
     */
    initSearch: function () {
        // 渲染下拉框
        // var typeSelect = document.querySelector('.search-area select[name="type"]');
        // for(let key in TYPE_MAP) {
        //     const option = document.createElement('option');
        //     option.value = key;
        //     option.innerText = TYPE_MAP[key];
        //     typeSelect.appendChild(option);
        // }

        // 绑定搜索事件
        document.querySelector('.search-action').addEventListener('click', function () {
            var _query = {
               
                year: document.querySelector('[name="year"]').value,
                month: document.querySelector('[name="month"]').value,
                // expensesType: document.querySelector('[name="expensesType"]').value,
               
            };
            table.GM('setQuery', _query, function () {
                console.log('setQuery执行成功');
            });
        });

        // 绑定重置
        document.querySelector('.reset-action').addEventListener('click', function () {
            var now = new Date();
          
            document.querySelector('[name="year"]').value = now.getFullYear();
            document.querySelector('[name="month"]').value = '';
            // document.querySelector('[name="expensesType"]').value = '';
            
        });
    },



    /**
     * 初始化表格
     */
    initGM: function () {
        new window.GridManager(table, {
            gridManagerName: 'test',
            width: '100%',
            height: '100%',

           

            supportAutoOrder: false,

            supportCheckbox: false,
            // 选择框配置
            // checkboxConfig: {
            //     // 使用单选
            //     // useRadio: true,

            //     // 使用行选中
            //     // useRowCheck: true,

            //     key: 'id',
            //     // 复选时最大可选数
            //     // max: 2,

            //     // 固定列
            //     fixed: 'left'
            // },

            // 是否使用无总条数模式
            // useNoTotalsMode: true,
            // 是否开启分页
            supportAjaxPage: false,
            // 排序模式，single(升降序单一触发) overall(升降序整体触发)
            sortMode: 'single',

            // supportAdjust: false,





            // 右键菜单
            supportMenu: true,
            // menuHandler: list => {
            //     list.unshift({
            //         content: '自定义菜单',
            //         line: true,
            //         onClick: _ => {
            //             alert(_);
            //         }
            //     });
            //     return list;
            // },

            // 禁用分割线
            // disableLine: true,

            // 设置表头的icon图标是否跟随文本
            // isIconFollowText: true,

            // 组合排序
            // isCombSorting: true,

            // 合并排序
            // mergeSort: true,

            // 禁用边框线
            // disableBorder: true,

            // 行移动
            // supportMoveRow: true,
            // moveRowConfig: {
            //     key: 'priority',
            //     useSingleMode: true,
            //     fixed: 'left',
            //     handler: (list, tableData) => {
            //         //console.log(list, tableData);
            //     }
            // },

            // 禁用缓存
            disableCache: false,
            ajaxData: function (settings, params) {
                // document.querySelector('[name="categoryId"]').value = params.categoryId || "";
                return '/json/income/collect';
            },

            // 导出配置
            exportConfig: {
                fileName: query => {
                    const date = new Date();
                    let fileName = `${date.getFullYear()}-${date.getMonth() + 1}-${date.getDate()}`;
                    for (let key in query) {
                        fileName = `${fileName}-${key}=${query[key]}`;
                    }
                    return fileName;
                },
                suffix: 'xls'
            },
            ajaxType: 'GET',

            // 选择事件执行前事件
            checkedBefore: function (checkedList, isChecked, row) {
                console.log('checkedBefore==', checkedList, isChecked, row);
                if (row && row.id === 90) {
                    alert('该节点在checkedBefore中配置为不可选');
                }
                return row && row.id !== 90;
            },



            // 执行请求后执行程序
            // responseHandler: res => {
            //     res.data.forEach(item => {
            //         // 用id模拟优先级字段
            //         item.priority = item.id;
            //     });
            //     return res;
            // },

            // 单行数据渲染时执行程序
            // rowRenderHandler: (row, index) => {
            //     // if (row.id === 90) {
            //     //     row.gm_checkbox = true;
            //     // }

            //     // 指定第92行不可选中
            //     if (row.id === 92) {
            //         // row.gm_checkbox = true;
            //         row.gm_checkbox_disabled = true;
            //         row.gm_row_class_name = 'test-row-class';
            //     }
            //     return row;
            // },

            emptyTemplate: settings => {
                return `<div style="text-align: center;">${settings.query.title ? '搜索为空' : '暂无数据'}</div>`;
            },
            // 单个td的hover事件
            // cellClick: (row, rowIndex, colIndex) => {
            //     // console.log(row, rowIndex, colIndex);
            //     return {
            //         text: '这里有个提示',
            //         position: 'left'
            //     };
            // },
            // rowHover: (a, b, c) => {
            //     return {
            //         text: '这里有个提示',
            //         position: 'right'
            //     };
            // },
            //  useWordBreak: true,
            // fullColumn: {
            //     useFold: true,
            //     fixed: 'left', // 折叠事件列固定方向
            //     openState: false,
            //     bottomTemplate: function(row, index){
            //         return `
            //         <p>费用说明</p>
            //         <pre>${row.explanation}</pre>`;
            //     }
            // },
            columnData: [
                {
                    key: 'month',
                    width: '60px',
                    fixed: 'left',
                    align: 'center',
                    disableMoveRow: true,
                    disableRowCheck: true,
                    text: '月/日',
                },
                {
                    key: 'bankDepositPrice',
                    remind: '利息收入',
                    align: 'center',
                    width: '120px',
                    text: '银行存款',
                    template: function (title, row) {
                        if(row.bankDepositPrice==0){
                            return "";
                        }
                        return row.bankDepositPrice;
                    }
                    // children: [
                    //     {
                    //         key: 'username',
                    //         text: '银行存款',
                    //         align: 'center',
                    //     },
                    //     {
                    //         key: 'username2',
                    //         text: '活期理财收益',
                    //         align: 'center',
                    //     },
                    //     {
                    //         key: 'username3',
                    //         text: '固定理财收益',
                    //         align: 'center',
                    //     },
                    //     {
                    //         key: 'username4',
                    //         text: '个人借款',
                    //         align: 'center',
                    //     },
                    //     {
                    //         key: 'username5',
                    //         text: '小计',
                    //         align: 'center',
                    //     },
                    // ],
                },
                {
                    key: 'currentFinancPrice',
                    remind: '利息收入',
                    align: 'center',
                    width: '120px',
                    text: '活期理财收益',
                    template: function (title, row) {
                        if(row.currentFinancPrice==0){
                            return "";
                        }
                        return row.currentFinancPrice;
                    },
                },
                {
                    key: 'fixedFinancPrice',
                    remind: '利息收入',
                    align: 'center',
                    width: '120px',
                    text: '固定理财收益',
                    template: function (title, row) {
                        if(row.fixedFinancPrice==0){
                            return "";
                        }
                        return row.fixedFinancPrice;
                    },
                },
                {
                    key: 'personalLoanPrice',
                    remind: '利息收入',
                    align: 'center',
                    width: '120px',
                    text: '个人借款',
                    template: function (title, row) {
                        if(row.personalLoanPrice==0){
                            return "";
                        }
                        return row.personalLoanPrice;
                    },
                },
                {
                    key: 'interestSubtotalPrice',
                    remind: '利息收入',
                    align: 'center',
                    width: '120px',
                    text: '小计',
                    template: function (title, row) {
                        if(row.interestSubtotalPrice==0){
                            return "";
                        }
                        return row.interestSubtotalPrice;
                    },
                },
                {
                    key: 'socialSecurity',
                    remind: '补贴收入',
                    align: 'center',
                    width: '120px',
                    text: '社保',
                    template: function (title, row) {
                        if(row.socialSecurity==0){
                            return "";
                        }
                        return row.socialSecurity;
                    },
                },
                {
                    key: 'finance',
                    remind: '补贴收入',
                    align: 'center',
                    width: '120px',
                    text: '财政',
                    template: function (title, row) {
                        if(row.finance==0){
                            return "";
                        }
                        return row.finance;
                    },
                },
                {
                    key: 'subsidySubtotal',
                    remind: '补贴收入',
                    align: 'center',
                    width: '120px',
                    text: '小计',
                    template: function (title, row) {
                        if(row.subsidySubtotal==0){
                            return "";
                        }
                        return row.subsidySubtotal;
                    },
                },
                // {
                //     key: 'typeShow',
                //     width: '240px',
                //     text: '补贴收入',
                //     children: [
                //         {
                //             key: 'username',
                //             text: '社保',
                //             align: 'center',
                //         },
                //         {
                //             key: 'username2',
                //             text: '财政',
                //             align: 'center',
                //         },
                //         {
                //             key: 'username5',
                //             text: '小计',
                //             align: 'center',
                //         },
                //     ],
                // },
                
                {
                    key: 'reserveFund',
                    remind: '借款收回',
                    align: 'center',
                    width: '120px',
                    text: '备用金',
                    template: function (title, row) {
                        if(row.reserveFund==0){
                            return "";
                        }
                        return row.reserveFund;
                    },
                },
                {
                    key: 'privateBorrow',
                    remind: '借款收回',
                    align: 'center',
                    width: '120px',
                    text: '私人借款',
                    template: function (title, row) {
                        if(row.privateBorrow==0){
                            return "";
                        }
                        return row.privateBorrow;
                    },
                },
                {
                    key: 'loanSubtotal',
                    remind: '借款收回',
                    align: 'center',
                    width: '120px',
                    text: '小计',
                    template: function (title, row) {
                        if(row.loanSubtotal==0){
                            return "";
                        }
                        return row.loanSubtotal;
                    },
                },
                // {
                //     key: 'priceShow',
                //     width: '240px',
                //     text: '借款收回',
                //     children: [
                //         {
                //             key: 'username',
                //             text: '备用金',
                //             align: 'center',
                //         },
                //         {
                //             key: 'username2',
                //             text: '私人借款',
                //             align: 'center',
                //         },
                //         {
                //             key: 'username5',
                //             text: '小计',
                //             align: 'center',
                //         },
                //     ],
                // },
                {
                    key: 'zongheng',
                    width: '120px',
                    align: 'center',
                    text: '纵横知道',
                    template: function (title, row) {
                        if(row.zongheng==0){
                            return "";
                        }
                        return row.zongheng;
                    },
                },
                {
                    key: 'returnRemittance',
                    width: '120px',
                    text: '退汇',
                    disableMoveRow: true,
                    template: function (title, row) {
                        if(row.returnRemittance==0){
                            return "";
                        }
                        return row.returnRemittance;
                    },
                },
                
                {
                    key: 'bond',
                    text: '保证金',
                    width: '120px',
                    disableMoveRow: true,
                    template: function (title, row) {
                        if(row.bond==0){
                            return "";
                        }
                        return row.bond;
                    },
                },
                {
                    key: 'other',
                    text: '其他',
                    width: '120px',
                    disableMoveRow: true,
                    template: function (title, row) {
                        if(row.other==0){
                            return "";
                        }
                        return row.other;
                    },
                },
                {
                    key: 'subtotal',
                    text: '合计',
                    width: '100px',
                    fixed: 'right',
                    disableMoveRow: true,
                    disableRowCheck: true,
                    template: function (title, row) {
                        if(row.subtotal==0){
                            return "";
                        }
                        return row.subtotal;
                    },
                },


            ]
        }, query => {
            // 渲染完成后的回调函数
        });
    },

    /**
     * 编辑功能
     */
    editRowData: function (dom) {
        window.GridManager.updateRowData('test', 'id', { id: window.parseInt(dom.getAttribute('data-id')), lastDate: new Date().getTime() });
    }
};

// GridManager 渲染
const table = document.querySelector('#feeList');

demo1.initSearch(table);
demo1.initGM(table);
//demo1.initFN();

