<?php
/*
 * @description: 费用管理控制类 @Author: CP @Date: 2020-11-11 17:51:05 @FilePath: \cld\protected\controller\fee\fee_controller.php
 */
require "protected/services/fee_service.php";
require "protected/services/incomeExpenses_service.php";

require "protected/services/region_service.php";
require "protected/services/office_service.php";
require "protected/services/staff_service.php";
require "protected/class/comm_cld.php";
class fee_controller extends DooController {
	private $staff;
	private $verifyId;
	private $executeId;
	private $feeService;
	private $regionService;
	private $officeService;
	private $staffService;
	private $incomeExpensesService;
	
	// 构建申请报销单页面
	public function GetViewReceiptCreate() {
		// 请求
		$data ['action'] = "/receipt/create";
		
		// 费用 项目细则
		$accountItem = $this->feeService->GetAccountItem ();
		$data ['accountItem'] = json_encode ( $accountItem );
		
		// 地区
		$region = $this->regionService->GetRegionTwo ();
		$data ['region'] = json_encode ( $region );
		
		// 审批
		//GetVerify
		$data ['verify'] = json_encode ( $this->feeService->GetVerifyType ('RECEIPT') );
		
		// 办事处
		$data ['office'] = $this->officeService->GetAll ();
		// 默认办事处
		$data ['officeId'] = $this->staff ['cid'];
		
		//设置默认差旅地区
		$traveDefault=$this->makeTraveDefault($region);
		$data['defaultTraveProvince']=$traveDefault['defaultTraveProvince'];
		$data['defaultTraveProvinceIndex']=$traveDefault['defaultTraveProvinceIndex'];
		
		// 附件
		$data ['enclosurList'] = array ();
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'saeaBorad';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/create/receipt", $data );
	}
	
	// 编辑报销单
	public function GetViewReceiptEdit() {
		$receiptId = isset ( $this->params ['receiptId'] ) ? $this->params ['receiptId'] : '';
		if (empty ( $receiptId )) {
			die ( 'illegal request-请求参数错误，重新请求' );
		}
		
		$receiptId = GetDecryptId ( $receiptId );
		$detail = $this->feeService->GetReceipt ( $receiptId );
		
		// 附件相关
		Doo::loadModel ( 'enclosur' );
		$enclosur = new enclosur ();
		$data ['enclosurList'] = $enclosur->getEnclosurByRid ( $detail ['rid'] );
		
		// 费用 项目细则
		$accountItem = $this->feeService->GetAccountItem ();
		$data ['accountItem'] = json_encode ( $accountItem );
		// 报销单数据
		
		$data ['data'] = json_encode ( $this->makeReceiptEdiData ( $detail, $accountItem, $this->feeService->GetVerifyType ('RECEIPT') ) );
		// 请求
		$data ['action'] = "/receipt/edit";
		
		// 地区
		$region = $this->regionService->GetRegionTwo ();
		$data ['region'] = json_encode ( $region );
		// 审批
		$data ['verify'] = "[]";
		// 办事处
		$data ['office'] = $this->officeService->GetAll ();
		// 默认办事处
		$data ['officeId'] = $detail ['cid'];
		$data ['receiptId'] = $detail ['receiptId'];
		
		$data['status']=$detail['status'];
		
		//设置默认差旅地区
		$traveDefault=$this->makeTraveDefault($region);
		$data['defaultTraveProvince']=$traveDefault['defaultTraveProvince'];
		$data['defaultTraveProvinceIndex']=$traveDefault['defaultTraveProvinceIndex'];
		
		$this->staff['remittanceName']=$detail['remittanceName'];
		$this->staff['remittanceBankType']=$detail['remittanceBankType'];
		
		$this->staff['bankName']=$detail['bankName'];
		$this->staff['bankNumber']=$detail['bankNumber'];
		$this->staff['coupletNumber']=$detail['coupletNumber'];
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'saeaBorad';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/create/receipt", $data );
	}
	
	// 创建报销单
	public function PostReceiptCreate() {
		
		// 1.获得参数
		$data = array (
				"officeData" => get_args ( 'officeData' ),
				"traveData" => get_args ( 'traveData' ),
				"trainData" => get_args ( 'trainData' ),
				"enclosurFiles" => get_args ( 'enclosurFiles' ),
				"verifyId" => get_args ( 'verifyId' ),
				"officeId" => get_args ( 'officeId' ),
				"remittanceName" => get_args ( 'remittanceName' ),
				"remittanceBankType" => get_args ( 'remittanceBankType' ),
				"bankName" => get_args ( 'bankName' ),
				"bankNumber" => get_args ( 'bankNumber' ),
				"coupletNumber" => get_args ( 'coupletNumber' ) 
		);
		
		// 2.参数校验
		$data = $this->feeService->ValidRuleReceiptCreate ( $data );
		
		// 3.具体数据处理
		$msg = $this->feeService->ReceiptCreate ( $data, $this->staff );
		
		return "/saeaBorad";
	}
	
	// 更新报销单
	public function PostReceiptEdit() {
		// 1.获得参数
		$data = array (
				"receiptId" => get_args ( 'receiptId' ),
				"officeData" => get_args ( 'officeData' ),
				"traveData" => get_args ( 'traveData' ),
				"trainData" => get_args ( 'trainData' ),
				"enclosurFiles" => get_args ( 'enclosurFiles' ),
				"verifyId" => get_args ( 'verifyId' ),
				"officeId" => get_args ( 'officeId' ),
				"remittanceName" => get_args ( 'remittanceName' ),
				"remittanceBankType" => get_args ( 'remittanceBankType' ),
				"bankName" => get_args ( 'bankName' ),
				"bankNumber" => get_args ( 'bankNumber' ),
				"coupletNumber" => get_args ( 'coupletNumber' ) 
		);
		
		// 2.参数校验
		$data = $this->feeService->ValidRuleReceiptCreate ( $data );
		// 3.具体数据处理
		$msg = $this->feeService->ReceiptEdi ( $data, $this->staff );
		
		return "/saeaBorad";
	}
	
	// 创建借款报销单
	public function GetViewLoanReceiptCreate() {
		
// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		
		$receiptId = isset ( $this->params ['receiptId'] ) ? $this->params ['receiptId'] : '';
		if (empty ( $receiptId )) {
			die ( 'illegal request-请求参数错误，重新请求' );
		}
		
		$data ['receiptId'] = $receiptId;
		
		$receiptId = GetDecryptId ( $receiptId );
		$detail = $this->feeService->GetReceipt ( $receiptId );
		
		// 设置借款信息
		$loan = $this->feeService->GetLoanReceipt ( $detail ['loanRid'],$this->staff );
		$data ['loan'] = $loan;
		
		// 费用 项目细则
		$accountItem = $this->feeService->GetAccountItem ();
		$data ['accountItem'] = json_encode ( $accountItem );
		// 报销单数据
		if ($detail ['status'] != 7) {
			$detail ['verify'] = '';
		}
		
		$verifyList=$this->feeService->GetVerifyType ('RECEIPT');
		
		$data ['data'] = json_encode ( $this->makeReceiptEdiData ( $detail, $accountItem, $verifyList ) );
		// 地区
		$region = $this->regionService->GetRegionTwo ();
		$data ['region'] = json_encode ( $region );
		
		// 审批
		$data ['verify'] = json_encode ( $verifyList );
		
		// 办事处
		$data ['office'] = $this->officeService->GetAll ();
		// 默认办事处
		$data ['officeId'] = $this->staff ['cid'];
		// 附件
		$data ['enclosurList'] = array ();
		// 请求
		$data ['action'] = "/loan/receipt/edit";
		
		$traveDefault=$this->makeTraveDefault($region);
		$data['defaultTraveProvince']=$traveDefault['defaultTraveProvince'];
		$data['defaultTraveProvinceIndex']=$traveDefault['defaultTraveProvinceIndex'];
// 		$defaultTraveProvince="";
// 		if($this->staff['category']=="总部"){
// 			$defaultTraveProvince="广东省";
// 		}else{
// 			$defaultTraveProvince=str_replace("办","省",$this->staff['category']);
// 		}
// 		$data['defaultTraveProvince']=$defaultTraveProvince;
		
		// 获得二级地区的index
// 		$defaultTraveProvinceIndex=0;
// 		foreach ($region as $key=>$value){
// 			if($value['name']==$defaultTraveProvince){
// 				$defaultTraveProvinceIndex=$key;
// 			}
// 		}
// 		$data['defaultTraveProvinceIndex']=$defaultTraveProvinceIndex;
		
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'saeaBorad';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/create/receipt", $data );
	}
	
	// 保存借款报销单
	public function PostLoanReceiptEdit() {
		// 1.获得参数
		$data = array (
				"receiptId" => get_args ( 'receiptId' ),
				"officeData" => get_args ( 'officeData' ),
				"traveData" => get_args ( 'traveData' ),
				"trainData" => get_args ( 'trainData' ),
				"enclosurFiles" => get_args ( 'enclosurFiles' ),
				"verifyId" => get_args ( 'verifyId' ),
				"officeId" => get_args ( 'officeId' ),
				"remittanceName" => get_args ( 'remittanceName' ),
				"remittanceBankType" => get_args ( 'remittanceBankType' ),
				"bankName" => get_args ( 'bankName' ),
				"bankNumber" => get_args ( 'bankNumber' ),
				"coupletNumber" => get_args ( 'coupletNumber' ) 
		);
		// 2.参数校验
		$data = $this->feeService->ValidRuleReceiptCreate ( $data );
		
		// 3.处理借款报销单数据
		$msg = $this->feeService->LoanReceiptEdi ( $data ['receiptId'] );
		
		// 4.具体数据处理
		$msg = $this->feeService->ReceiptEdi ( $data, $this->staff );
		
		return "/saeaBorad";
	}
	
	// 审批页面
	public function GetViewReceiptApproval() {
		$receiptId = isset ( $this->params ['receiptId'] ) ? $this->params ['receiptId'] : '';
		if (empty ( $receiptId )) {
			die ( 'illegal request-请求参数错误，重新请求' );
		}
		$receiptId = GetDecryptId ( $receiptId );
		$detail = $this->feeService->GetReceipt ( $receiptId );
		
		
		// 设置借款信息
		if (!empty($detail ['loanRid'])){
			$loan = $this->feeService->GetLoanReceipt ( $detail ['loanRid'] );
			$data ['loan'] = $loan;
		}
		
		$data['receipt']=$detail;
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'saeaBorad';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/approval/receipt", $data );
		
	}
	
	// 获得个人所有的差旅时间
	public function GetJsonTraveDateAll(){
		$traveData=$this->feeService->GetTraveDateAll($this->staff['sid']);
		echo json_encode($traveData);
	}
	
	//报销单检索
	public function GetViewFee() {
// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		//员工
		$data['staffSelect']=$this->staffService->GetStaffCategoryId();
		
		// 办事处
		$data ['office'] = $this->officeService->GetAll ();
		
		$data ['yearHtml'] = GetYear();
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'feeList';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/list", $data );
	}
	
	//获得费用列表 
	public function GetJsonFee(){
		// 1.获得参数
		$data = array (
				"cPage" => get_args ( 'cPage' ),
				"pSize" => get_args ( 'pSize' ),
				"sort_createDate" => get_args ( 'sort_createDate' ),
				"categoryId" => get_args ( 'categoryId' ),
				"feeType" => get_args ( 'feeType' ),
				"kw" => get_args ( 'kw' ),
				"month" => get_args ( 'month' ),
				
				"staffId" => get_args ( 'staffId' ),
				"year" => get_args ( 'year' )
		);
		
		$data=$this->feeService->GetFeePage($data);
		
		echo json_encode(array(
				"status"=>"success",
				"totals"=>$data['count'],
				"data"=>$data['list'],
		));
//  		echo '{"status":"success","totals":62,"data":[{"id":106,"author":"33","praiseNumber":"0","status":1,"readNumber":338,"pic":"/upload/blog/pic/4746_1602504257005.png","title":"表格组件实现打印功能","subtitle":"打印,表格组件打印","type":3,"info":"这是一个不是很常用的功能，但却是在不经意间提升用户体验。","createDate":1602504114000,"lastDate":1602504286042,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":105,"author":"33","praiseNumber":"0","status":1,"readNumber":364,"pic":"/upload/blog/pic/5168_1597745000561.png","title":"表格组件GridManager的嵌套表头详解","subtitle":"gridmanager,嵌套表格","type":3,"info":"嵌套表头这个功能在经历了多次调整后，终于在V2.13.0这个版本内发布。","createDate":1597744702000,"lastDate":1597745002433,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":102,"author":"33","praiseNumber":"0","status":1,"readNumber":380,"pic":"/upload/blog/pic/949_1594620668048.png","title":"GridManager loading样式修改","subtitle":"gridmanager","type":3,"info":"在使用gridmanager表格组件时，如果想要改变loading样式该如何处理?","createDate":1591238998000,"lastDate":1594620669622,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":101,"author":"33","praiseNumber":"0","status":1,"readNumber":122,"pic":"/upload/blog/pic/622_logo.png","title":"GridManager Error: response.totals undefined，please check totalsKey","subtitle":"GridManager Error","type":3,"info":"GridManager Error 解决方法","createDate":1590291381000,"lastDate":1594375210507,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":100,"author":"33","praiseNumber":"0","status":1,"readNumber":57,"pic":"/upload/blog/pic/5718_logo.png","title":"GridManager Error: response.data is not Array,please check dataKey","subtitle":"GridManager Error","type":3,"info":"GridManager Error: response.data is not Array,please check dataKey 错误的解决方法","createDate":1590143273000,"lastDate":1594375303196,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":98,"author":"33","praiseNumber":"0","status":1,"readNumber":184,"pic":"/upload/blog/pic/9933_1594620719884.png","title":"如何解决错综复杂的表格数据（GridManager随笔）","subtitle":"grdmanager,js,导出","type":3,"info":"自从前后端分离的模式推广以后，前后端的开发人员就开始了针对于数据格式的相爱相杀。","createDate":1588147257000,"lastDate":1594620726750,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":96,"author":"33","praiseNumber":"0","status":1,"readNumber":248,"pic":"/upload/blog/pic/4366_316_logo.png","title":"表格组件GridManager的固定列详解","subtitle":"angular,vue,react,原生表格","type":3,"info":"表格固定列的使用详解","createDate":1583980062000,"lastDate":1583980164961,"commentSum":2,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":94,"author":"33","praiseNumber":"0","status":1,"readNumber":353,"pic":"/upload/blog/pic/1887_1594621045179.png","title":"表格导出功能实践","subtitle":"grdmanager,js,导出","type":3,"info":"表格导出功能实践","createDate":1579350185000,"lastDate":1594621047404,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":92,"author":"33","praiseNumber":"0","status":1,"readNumber":836,"pic":"/upload/blog/pic/7539_type.jpg","title":"Content-Type 对照表","subtitle":"Content-Type,Mime-Type","type":3,"info":"Content-Type(Mime-Type)对照表, 有不全的会继续更新","createDate":1533263664000,"lastDate":1558979256770,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":90,"author":"33","praiseNumber":"0","status":1,"readNumber":673,"pic":"/upload/blog/pic/3438_vue-gridmanager.png","title":"Vue框架内使用GridManager","subtitle":"vue,vue gridmanager, gridmanager","type":3,"info":"GridManager对Vue很友好，发布了针对于Vue的npm包。","createDate":1528088965000,"lastDate":1558979136519,"commentSum":1,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":89,"author":"33","praiseNumber":"0","status":1,"readNumber":488,"pic":"/upload/blog/pic/4289_1594620821109.png","title":"GridManager 导出","subtitle":"GridManager导出功能","type":3,"info":"GridManager 具有表格数据导出功能，该功能为纯前端实现，对后端无依赖。","createDate":1526276639000,"lastDate":1594620823667,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":88,"author":"33","praiseNumber":"0","status":1,"readNumber":220,"pic":"/upload/blog/pic/329_1594620833046.png","title":"GridManager 用户偏好记忆","subtitle":"GridManager 用户记忆, GridManager 用户偏好记忆","type":3,"info":"GridManager 会将用户的部分操作进行记忆，从而达到用户行为记忆的效果。","createDate":1525929957000,"lastDate":1594620834782,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":87,"author":"33","praiseNumber":"0","status":1,"readNumber":231,"pic":"/upload/blog/pic/8909_GridManager%E9%9A%90%E8%97%8F%E5%88%97.png","title":"GridManager 隐藏列","subtitle":"gridmanager, 隐藏列","type":3,"info":"GridManager 表格管理组件， 可以便捷的对列的显示状态进行操作。","createDate":1525873470000,"lastDate":1558979068145,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":84,"author":"33","praiseNumber":"0","status":1,"readNumber":213,"pic":"/upload/blog/pic/3533_buhuo.png","title":"js捕获错误信息","subtitle":"js error,捕获错误信息","type":3,"info":"这个不是很常用的功能， 但是想收集客户端的错误信息时却很有必要了解下。 ","createDate":1512053637000,"lastDate":1512114137868,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":83,"author":"33","praiseNumber":"0","status":1,"readNumber":223,"pic":"/upload/blog/pic/9396_1594620989874.png","title":"div绑定键盘事件","subtitle":"div keydown, div keyup","type":3,"info":"在给如div等元素绑定键盘事件(如keydown)时， 会发现绑定是失效的。","createDate":1511696284000,"lastDate":1594620991837,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":82,"author":"33","praiseNumber":"0","status":1,"readNumber":323,"pic":"/upload/blog/pic/5522_1594621083765.png","title":"GridManager 调整数据格式","subtitle":"gridmanager, gridmanager数据格式,gridmanager数据","type":3,"info":"GridManager在处理数据时，需要使用规定的数据格式。而在实际场景中，或多或少存在一些格式差异。在这里将对这些差异的处理方式进行说明","createDate":1510671378000,"lastDate":1594621087383,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":81,"author":"33","praiseNumber":"0","status":1,"readNumber":225,"pic":"/upload/blog/pic/6849_1594621100048.png","title":"GridManager 实现搜索","subtitle":"GridManager搜索, 表格,gridmanager","type":3,"info":"搜索功能在GridManager中的实现方式很简单，可通过setQuery方法实现。","createDate":1510581680000,"lastDate":1594621101656,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":80,"author":"33","praiseNumber":"0","status":1,"readNumber":137,"pic":"/upload/blog/pic/5676_1594621160163.png","title":"GridManager宽度配置不生效与出现滚动条","subtitle":"GridManager,GridManager宽度配置不生效,GridManager出现滚动条,GridManager宽度","type":3,"info":"某一例配置的宽度为100px, 而生成的宽度却不是100px，并且出现了横向滚动条?","createDate":1508678057000,"lastDate":1594621161393,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":79,"author":"33","praiseNumber":"0","status":1,"readNumber":206,"pic":"/upload/blog/pic/24_1594621175986.png","title":"GridManager常见问题","subtitle":"GridManager,GridManager问题,GridManager常见问题","type":3,"info":"这里收集了一些GridManager常见问题。","createDate":1508422239000,"lastDate":1594621177621,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"},{"id":78,"author":"33","praiseNumber":"0","status":1,"readNumber":190,"pic":"/upload/blog/pic/3747_1594621196206.png","title":"GridManager排序详解","subtitle":"GridManager排序,GridManager,GridManager排序详解,GridManager排序使用,GridManager组合排序","type":3,"info":"GridManager排序原理及常见问题汇总","createDate":1508332140000,"lastDate":1594621199429,"commentSum":0,"username":"写个程序换个饼","photo":"/upload/user/photo/8495_1.jpg"}]}';
	
	}
	
	//获得办事处员工
	public function PostJsonStaffCategory(){
		$data = array (
				"categoryId" => get_args ( 'categoryId' ),
		);
		
		$staffList=$this->staffService->GetStaffCategoryId($data['categoryId']);
		echo json_encode($staffList);
	}
	
// 	所有收支
	public function GetViewIncomeExpenses(){
		
// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		
		
		$data ['yearHtml'] = GetYear();
		
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'payments';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/incomeExpenses/list", $data );
		
	}
	
	//获得费用列表
	public function GetJsonIncomeExpenses(){
// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		// 1.获得参数
		$data = array (
				"cPage" => get_args ( 'cPage' ),
				"pSize" => get_args ( 'pSize' ),
				"sort_createDate" => get_args ( 'sort_createDate' ),
				
				"kw" => get_args ( 'kw' ),
				"year" => get_args ( 'year' ),
				"month" => get_args ( 'month' ),
	
				"expensesType" => get_args ( 'expensesType' ),
				"accountType" => get_args ( 'accountType' ),
				"expenditureType" => get_args ( 'expenditureType' ),
				
		);
	
		$data=$this->incomeExpensesService->GetIncomeExpensesPage($data);
	
		echo json_encode(array(
				"status"=>"success",
				"totals"=>$data['count'],
				"data"=>$data['list'],
		));
	}
	
	// 	所有收支
	public function GetViewIncomeCollect(){
// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		$data ['yearHtml'] = GetYear();
	
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'paymentsCollect';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/incomeExpenses/income", $data );
	
	}
	
	//获得费用列表
	public function GetJsonIncomeCollect(){
		// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		// 1.获得参数
		$data = array (
				"cPage" => get_args ( 'cPage' ),
				"pSize" => get_args ( 'pSize' ),
				
				"expensesType"=>1 ,
				"year" => get_args ( 'year' ) ? get_args ( 'year' ): date("Y"),
				"month" => get_args ( 'month' ),
		);
	
		$data=$this->incomeExpensesService->GetIncomeCollect($data);
	
		echo json_encode(array(
				"status"=>"success",
				"totals"=>1000,
				"data"=>$data,
		));
	}
	
	// 	所有收支
	public function GetViewExpensesCollect(){
		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		$data ['yearHtml'] = GetYear();
	
		$data ['staff'] = $this->staff;
		$data ['verifyId'] = $this->verifyId;
		$data ['executeId'] = $this->executeId;
		$data ['receiptMemu'] = 'paymentsCollect';
		$data ['memu'] = "receipt";
		$this->render ( "/fee/incomeExpenses/expenses", $data );
	}
	
	//获得费用列表
	public function GetJsonExpensesCollect(){
		// 		include Doo::conf ()->BASE_PATH . 'diagnostic/debug.php';
		// 1.获得参数
		$data = array (
				"cPage" => get_args ( 'cPage' ),
				"pSize" => get_args ( 'pSize' ),
	
				"expensesType"=>2 ,
				"year" => get_args ( 'year' ) ? get_args ( 'year' ): date("Y"),
				"month" => get_args ( 'month' ),
		);
	
		$data=$this->incomeExpensesService->GetExpensesCollect($data);
	
		echo json_encode(array(
				"status"=>"success",
				"totals"=>1000,
				"data"=>$data,
		));
	}
	
	
	
	
	
	
	
	
	
	public function beforeRun($resource, $action) {
		$this->accessAuth ( $resource, $action );
	}
	function __construct() {
		$this->session ();
		$this->feeService = new fee_service ();
		$this->regionService = new region_service ();
		$this->officeService = new office_service ();
		$this->staffService = new staff_service ();
		$this->incomeExpensesService = new incomeExpenses_service ();
	}
	
	// 访问权限-费用管理
	private function accessAuth($resource, $action) {
		Doo::loadClass ( 'XDeode' );
		$XDeode = new XDeode ( 5 );
		$sid = $XDeode->decode ( $_COOKIE ["staff"] );
		// 1.单独判断公司汇总的访问权限
		if ($action == 'companyCategoryCollect') {
			Doo::loadModel ( "receiptAuthorityManage" );
			$invoiceCompanyManage = new receiptAuthorityManage ();
				
			$icm = $invoiceCompanyManage->getInvoiceCMByStaff ( $sid );
			if (empty ( $icm ))
				die ( 'illegal request-无权访问该页面' );
		}
	
		// 2.获得登陆用户信息
		Doo::loadModel ( 'cld/staff_cld' );
		$staff = new staff_cld ();
		$this->staff = $staff->Get ( $sid );
	
		// 3.是否有权限访问
		$accessModular = 'RECEIPTS';
		if (empty ( $this->staff ['cldAccessArray'] )) {
			die ( 'illegal request-无权访问费用页面，向总部申请权限' );
		} else {
			if (in_array ( $accessModular, $this->staff ['cldAccessArray'] )) {
				if (Doo::acl ()->isAllowed ( $accessModular, $resource, $action )) {
					$flag = true;
				} else {
					$flag = false;
				}
			} else {
				die ( 'illegal request-无权访问费用页面' );
			}
		}
		if (! $flag)
			die ( 'illegal request-无权访问费用页面' );
	}
	
	// 登陆判定
	private function session() {
		if (isset ( $_COOKIE ["staff"] )) {
				
			if (! empty ( $_COOKIE ["staff"] )) {
	
				Doo::loadModel ( 'staff' );
				Doo::loadModel ( 'verify' );
				$verify = new verify ();
				$staff = new staff ();
				Doo::loadModel ( "execute" );
				$execute = new execute ();
	
				$verifyList = $verify->find ( array (
						'select' => 'staff',
						'asArray' => true
				) );
				$list = array ();
	
				// 判断角色的审批权限
				foreach ( $verifyList as $key => $value ) {
					$ver = json_decode ( $value ['staff'] );
						
					foreach ( $ver as $k => $v ) {
						if ($v [1] == 'ROLE') {
							$roleList = json_decode ( $v [3] );
							foreach ( $roleList as $t => $g ) {
								$gList = explode ( "_", $g );
								array_push ( $list, $gList [0] );
								// print_r($list);
							}
						} else
							array_push ( $list, $v [0] );
					}
				}
	
				// 判断执行人的审批权限
				$executeList = $execute->find ( array (
						'where' => 'mold !="日常收支"',
						'select' => 'staff',
						'asArray' => true
				) );
				$list2 = array ();
				foreach ( $executeList as $key => $value ) {
					$ver = json_decode ( $value ['staff'] );
						
					foreach ( $ver as $k => $v ) {
						array_push ( $list2, $v [0] );
					}
				}
	
				$eidList = file_get_contents ( "protected/config/execute/execute.ini" );
				$eidList = array_filter ( explode ( ",", $eidList ) );
	
				$this->executeId = array_merge ( $list2, $eidList );
				// print_r($this->executeId);
				$this->verifyId = $list;
				// $this->staff = $staff->getUserByIdList ( $_COOKIE ["staff"] );
	
				return "/";
			}
		}
	
		Doo::loadCore ( 'uri/DooUriRouter' );
		$router = new DooUriRouter ();
		$routeRs = $router->execute ( Doo::app ()->route, Doo::conf ()->SUBFOLDER );
	
		if ($routeRs ['1'] != "login") {
			header ( 'Content-Type:text/html;charset=utf-8' );
			@header ( "Location: /login" );
		}
	}
	
	
	
	private function makeTraveDefault($region){
		$defaultTraveProvince="";
		if($this->staff['category']=="总部"||$this->staff['category']=="总部1"){
			$defaultTraveProvince="广东省";
		}elseif($this->staff['category']=="重庆办"){
			$defaultTraveProvince="重庆市";
		}else{
			$defaultTraveProvince=str_replace("办","省",$this->staff['category']);
		}
		
		// 获得二级地区的index
		$defaultTraveProvinceIndex=0;
		foreach ($region as $key=>$value){
			if($value['name']==$defaultTraveProvince){
				$defaultTraveProvinceIndex=$key;
			}
		}
		
		return array("defaultTraveProvince"=>$defaultTraveProvince,"defaultTraveProvinceIndex"=>$defaultTraveProvinceIndex);
	}
	
	// 构造页面数据
	private function makeReceiptEdiData($data, $accountItem, $verify) {
		$officeJson = array (
				"id" => 0,
				"name" => "办事处相关费用",
				"show" => false,
				"anchor" => "officeAnchor",
				"active" => false,
				"daily" => $accountItem ['daily'],
				"other" => $accountItem ['other'],
				"officeExplain" => array (
						
						0 => array (
								"officeExplain" => "" 
						) 
				) 
		);
		if (! empty ( $data ['officeJson'] )) {
			$officeJson = json_decode ( $data ['officeJson'], true );
		}
		
		$traveJson = array (
				"id" => 1,
				"name" => "差旅相关费用",
				"show" => false,
				"anchor" => "traveAnchor",
				"active" => false,
				"trave" => $accountItem ['trave'],
				"traveList" => array (),
				"traveExplain" => array (
						
						0 => array (
								"traveExplain" => "" 
						) 
				) 
		);
		if (! empty ( $data ['traveJson'] )) {
			$traveJson = json_decode ( $data ['traveJson'], true );
		}
		
		$trainJson = array (
				"id" => 2,
				"name" => "内部培训费用",
				"show" => false,
				"anchor" => "trainAnchor",
				"active" => false,
				"train" => $accountItem ['train'],
				"trainExplain" => array (
						0 => array (
								"trainExplain" => "" 
						) 
				)
				 
		);
		if (! empty ( $data ['trainJson'] )) {
			$trainJson = json_decode ( $data ['trainJson'], true );
		}
		
		return array (
				"receiptTypeMenu" => array (
						0 => $officeJson,
						1 => $traveJson,
						2 => $trainJson 
				),
				"verify" => $verify,
				"verifyId" => $data ['verify'],
				"remittanceBankType" => $data['remittanceBankType'],
				"enclosurFiles" => array (),
				"aletMsg" => '',
				"displayStsates" => 'none' 
		);
	}
}

?>