<?php
Doo::loadCore ( 'db/DooModel' );
class accountBook_cld extends DooModel {
	public $aid;
	public $expensesType;
	public $accountType;
	public $accountMsg;
	public $operatingBankType;
	public $depositMethod;
	public $receivedPrice;
	public $receivedMsg;
	public $receivedBank;
	public $receivedDate;
	public $expenditureType;
	public $expenditureMsg;
	public $expenditurePrice;
	public $expenditureBank;
	public $bookSerial;
	public $inputDate;
	public $remarks;
	public $expenditureDate;
	
	public $inputStaff;
	
	public $_table = 'CLD_accountBook';
	public $_primarykey = 'aid';
	public $_fields = array (
			'aid',
			'expensesType',
			'accountType',
			'accountMsg',
			'operatingBankType',
			'depositMethod',
			'receivedPrice',
			'receivedMsg',
			'receivedBank',
			'receivedDate',
			'expenditureType',
			'expenditureMsg',
			'expenditurePrice',
			'expenditureBank',
			
			'expenditureDate',
			
			'bookSerial',
			'remarks',
			'inputDate' ,
			'inputStaff'
	);
	
	public function GetExpensesType($data=array()){
		
		
		
		$startYear=$data['year']."-01-01:00.00.00";
		$endYear=$data['year']."-12-31:23.59.59";
		if(!empty($data['month'])){
			$days = cal_days_in_month(CAL_GREGORIAN, $data['month'], $data['year']);
			$startYear=$data['year']."-".$data['month']."-01:00.00.00";
			$endYear=$data['year']."-".$data['month']."-".$days.":23.59.59";
		}
		
		$sql=" ((expenditureDate>=? and expenditureDate<= ?) or (receivedDate>=? and receivedDate<= ?))  ";
		$param=array($startYear,$endYear,$startYear,$endYear);
		if(!empty($data['expensesType'])){
			$sql.=" and expensesType=? ";
			array_push($param, $data['expensesType']);
		}
		//获得数据
		$list = $this->find ( array (
				'select'=>' *	',
				'where' => $sql,
				'param' =>$param,
				'desc' => 'aid',
// 				'limit'=>$data['cPage'].','.$data['pSize'],
				'asArray' => TRUE
		));
		
		return $list;
	}
	
	//费用分页
	public function GetPage($data=array()){
	
		
		
		$startYear=$data['year']."-01-01:00.00.00";
		$endYear=$data['year']."-12-31:23.59.59";
		if(!empty($data['month'])){
			$days = cal_days_in_month(CAL_GREGORIAN, $data['month'], $data['year']);
			$startYear=$data['year']."-".$data['month']."-01:00.00.00";
			$endYear=$data['year']."-".$data['month']."-".$days.":23.59.59";
		}
		//(inputDate>=? and inputDate<= ?) or   $startYear,$endYear,
		$sql=" ((expenditureDate>=? and expenditureDate<= ?) or (receivedDate>=? and receivedDate<= ?))  ";
		$param=array($startYear,$endYear,$startYear,$endYear);
	
		if(!empty($data['expensesType'])){
			$sql.=" and expensesType=? ";
			array_push($param, $data['expensesType']);
		}
		
		if(!empty($data['accountType'])){
			$sql.=" and accountType=? ";
			array_push($param, $data['accountType']);
		}
		
		if(!empty($data['expenditureType'])){
			$sql.=" and expenditureType=? ";
			array_push($param, $data['expenditureType']);
		}
		
// 		if(!empty($data['staffId'])){
// 			$sql.=" and staff=? ";
// 			array_push($param, $data['staffId']);
// 		}else{
// 			if(!empty($data['categoryId'])){
// 				$sql.=" and cid=? ";
// 				array_push($param, $data['categoryId']);
// 			}
// 		}
	
		if(!empty($data['feeType'])){
			$sql.=" and Rtype=? ";
			array_push($param, $data['feeType']);
		}
	
		if(!empty($data['kw'])){
			$sql.=" and (bookSerial like ? or receivedPrice like ? or expenditurePrice like ? ) ";
			array_push($param, "%".$data['kw']."%");
			array_push($param, "%".$data['kw']."%");
			array_push($param, "%".$data['kw']."%");
		}
	
		//获得数据
		$list = $this->find ( array (
				'select'=>' *	',
				'where' => $sql,
				'param' =>$param,
				'desc' => 'aid',
				'limit'=>$data['cPage'].','.$data['pSize'],
				'asArray' => TRUE
		));
		
		
		
		$count=$this->count(array (
				'where' => $sql,
				'param' =>$param,
				'asArray' => TRUE
		));
	
		return array("count"=>$count,"list"=>$list);
	}
	
	
}

?>