<?php
Doo::loadCore ( 'db/DooModel' );
/**
 * 发票审批相关信息及其操作业务逻辑
 * @author CP.
 * @version 1.0
 * @namespace invoice
 * @package invoiceModel
 */
class invoice_cld extends DooModel {
	private $INVOICEKEY = "APPROVAL";
	private $FUZZY = 'FUZZY';
	private $EXACTLY = "EXACTLY";
	
	/**
	 *
	 * @var integer $iid 发票ID
	 */
	public $iid;
	public $isid;
	public $trainId;
	public $lossIid;
	public $ipSource;
	/**
	 *
	 * @var integer $status 审批状态
	 */
	public $status;
	/**
	 *
	 * @var string $invoiceManage 当前审批组人员
	 */
	public $printStatus;
	public $postStatus;
	public $invoiceForm;
	public $invoiceManage;
	/**
	 *
	 * @var string $pendingApprovals 当前需要审批的人
	 */
	public $pendingApprovals;
	/**
	 *
	 * @var string $processApprovals 已经审批过的人员
	 */
	public $processApprovals;
	/**
	 *
	 * @var string $invoiceSerial 发票单号
	 */
	public $invoiceSerial;
	/**
	 *
	 * @var integer $invoicePrice 发票金额
	 */
	public $invoicePrice;
	public $invoiceQuantity;
	public $invoiceUnitPrice;
	public $invoiceBalance;
	
	/**
	 * 管理组人员：发票打印，
	 * @var unknown
	 */
	public $moldManage;
	/**
	 *
	 * @var integer $cid 办事处ID
	 */
	public $cid;
	/**
	 *
	 * @var string $categoryName 办事处名称
	 */
	public $categoryName;
	/**
	 *
	 * @var integer $sid 提交发票人ID
	 */
	public $sid;
	/**
	 *
	 * @var string $userName 提交人名字
	 */
	public $printer;
	public $userName;
	/**
	 *
	 * @var string $remark 备注
	 */
	public $remark;
	/**
	 *
	 * @var string $invoiceElement 发票内容
	 */
	public $invoiceElement;
	/**
	 *
	 * @var string $invoiceType 发票类型
	 */
	public $invoiceType;
	/**
	 *
	 * @var string $invoiceTitle 发票抬头
	 */
	public $invoiceTitle;
	/**
	 *
	 * @var string $invoiceCompany 开票公司
	 */
	public $invoiceCompany;
	/**
	 *
	 * @var string $invoiceNo 发票号
	 */
	public $invoiceNo;
	/**
	 *
	 * @var string $TIN 纳税人识别码
	 */
	public $TIN;
	/**
	 *
	 * @var string $address 注册地址
	 */
	public $address;
	/**
	 *
	 * @var string $phone 电话
	 */
	public $phone;
	/**
	 *
	 * @var string $bank 开户银行
	 */
	public $bank;
	/**
	 *
	 * @var string $bankAccount 银行账户
	 */
	public $bankAccount;
	/**
	 *
	 * @var integer $doPost 邮寄
	 */
	public $doPost;
	/**
	 *
	 * @var string $recipients 收件人
	 */
	public $recipients;
	/**
	 *
	 * @var string $recipientsPhone 收件人电话
	 */
	public $recipientsPhone;
	/**
	 *
	 * @var string $recipientsAddress 收件地址
	 */
	public $recipientsAddress;
	/**
	 *
	 * @var string $mailItems 邮寄物品
	 */
	public $mailItems;
	public $mailItemsJson;
	public $expressCompany;
	public $expressNumber;
	public $actualItems;
	public $poster;
	public $untreadReason;
	public $untreadPost;
	public $untreadCompany;
	public $untreadNumber;
	public $untreadItems;
	public $untreadStatus;
	public $irid;
	public $bindTime;
	/**
	 *
	 * @var date $date 提交时间
	 */
	public $date;
	public $isDelete;
	public $approvalTime;
	/**
	 *
	 * @var date $updateTime 更新时间
	 */
	public $updateTime;
	/**
	 *
	 * @var date $printTime 打印时间
	 */
	public $printTime;
	public $postTime;
	public $settlementType;
	public $accountingTime;
	public $parentUntreadIid;
	public $inheritIid;
	public $electronicPhone;
	public $electronicEmail;
	public $invalid;
	public $badDebt;
	public $untreadTime;
	public $_table = 'CLD_invoice';
	public $_primarykey = 'iid';
	public $_fields = array (
			'iid',
			'isid',
			'trainId',
			'ipSource',
			'lossIid',
			'invoiceManage',
			'pendingApprovals',
			'processApprovals',
			'invoiceSerial',
			'status',
			'printStatus',
			'postStatus',
			'untreadStatus',
			'invoiceForm',
			'invoiceQuantity',
			'invoiceUnitPrice',
			'invoicePrice',
			'invoiceBalance',
			'moldManage',
			'cid',
			'categoryName',
			'irid',
			'remark',
			'invoiceElement',
			'invoiceType',
			'invoiceTitle',
			'invoiceCompany',
			'invoiceNo',
			'TIN',
			'address',
			'phone',
			'bank',
			'bankAccount',
			'doPost',
			'recipients',
			'recipientsPhone',
			'recipientsAddress',
			'mailItems',
			'mailItemsJson',
			'expressCompany',
			'expressNumber',
			'actualItems',
			'untreadReason',
			'untreadPost',
			'untreadCompany',
			'untreadNumber',
			'untreadItems',
			'poster',
			'sid',
			'userName',
			'printer',
			'date',
			'isDelete',
			'approvalTime',
			'updateTime',
			'printTime',
			'postTime',
			'bindTime',
			'settlementType',
			'accountingTime',
			'parentUntreadIid',
			'inheritIid',
			'electronicPhone',
			'electronicEmail',
			'invalid',
			'badDebt',
			'untreadTime' 
	);
	
	/**
	 * @Description: 根据培训班获得发票
	 * @author : caipin
	 */
	function GetTrainByStatus($trainId,$status=2,$untreadStatus=3) {
		$sql = "  trainId= ? and status=? and untreadStatus=?  and isDelete=0 ";
		$list = $this->find ( array (
				'where' => $sql,
				'param' => array (
						$trainId ,
						$status,
						$untreadStatus
				),
				'asArray' => TRUE 
		) );
		return $list;
	}
	/**
	 * @Description: 根据培训班获得发票
	 * @author : caipin
	 */
	function GetTrainByUnFinish($trainId) {
		$sql = "  trainId= ? and printStatus=1 and (untreadStatus =0 or untreadStatus=3) and isDelete=0  ";
		$list = $this->find ( array (
				'where' => $sql,
				'param' => array (
						$trainId ,
				),
				'asArray' => TRUE
		) );
		return $list;
	}
}

?>