<?php
Doo::loadCore ( 'db/DooModel' );
/**
 * 发票培训班相关信息及其操作业务逻辑
 * @author CP.
 * @version 1.0
 * @namespace invoice
 * @package invoiceModel
 */
class invoice_training_cld extends DooModel {
	public $itid;
	public $bindReceipt;
	public $status;
	public $submitStatus;
	public $trainName;
	public $cid;
	public $categoryName;
	public $creator;
	public $trainDate;
	public $invoiceTotal;
	public $invoiceTotalAmount;
	public $invoiceArriveAmount;
	public $arriveSchedule;
	public $creatorDate;
	public $settlementStatus;
	public $_table = 'CLD_invoiceTraining';
	public $_primarykey = 'itid';
	public $_fields = array (
			'itid',
			'bindReceipt',
			'status',
			'submitStatus',
			'trainName',
			'cid',
			'categoryName',
			'creator',
			'trainDate',
			'invoiceTotal',
			'invoiceTotalAmount',
			'invoiceArriveAmount',
			'arriveSchedule',
			'settlementStatus',
			'creatorDate' 
	);
	
	/**
	 * 获得根据办事处，创建人状态获得培训班 @date: 2021年1月21日 上午11:58:52
	 * @author : caipin
	 * @param : variable
	 */
	function getStatusByCategoryStaff($status, $categoryIdString, $staffId) {
		$sql = " status=2   ";
		if ($status == 0) {
			$sql = " status!=2   ";
		}
		$sql .= " and (cid in (?) or creator= ?) ";
		$list = $this->find ( array (
				'where' => $sql,
				'param' => array (
						$categoryIdString,
						$staffId 
				),
				'asArray' => TRUE 
		) );
		return $list;
	}
	function getInvoiceTrainingByTodo($select = "", $cid = 0, $sid = 0) {
		Doo::loadModel ( 'staff' );
		$staff = new staff ();
		Doo::loadModel ( 'L_category' );
		$lCategory = new L_category ();
		
		$condition = array (
				'where' => "(status= 0 or status=1) and ( cid in (" . $cid . ") or creator=" . $sid . " ) ",
				// 'limit' => 8,
				'asArray' => TRUE 
		);
		if (! empty ( $select ))
			$condition += array (
					'select' => $select 
			);
		
		$list = $this->find ( $condition );
		
		Doo::loadClass ( 'XDeode' );
		$XDeode = new XDeode ( 5 );
		$itid = array ();
		foreach ( $list as $key => $value ) {
			$list [$key] ['trainingKey'] = $XDeode->encode ( $value ['itid'] );
			$detail = $staff->getStaffBySid ( $value ['creator'] );
			$list [$key] ['staff'] = $detail;
			$detail = $lCategory->getCategoryById ( $value ['cid'] );
			$list [$key] ['category'] = $detail;
			array_push ( $itid, $value ['itid'] );
		}
		
		// 获得开票金额合计 入账金额合计 入账完成度
		Doo::loadModel ( 'invoice' );
		$invoice = new invoice ();
		
		$invoiceList = $invoiceRecelvablesList = array ();
		$itidSum = array ();
		if (! empty ( $itid )) {
			$itidSql = implode ( ',', $itid );
			$invoiceList = $invoice->sumOfinvoiceTrain ( $itidSql );
			
			// 1.所有培训班发票 收款合计
			$invoiceRecelvablesList = $invoice->InvoiceTrainIncomesPrice ( $itid );
			// print_r($invoiceRecelvablesList);
			// $invoiceRecelvablesList = $invoice->sumOfInvoiceRecelvablesTrain ( $itidSql );
			
			// 收款有多个发票绑定，导致收款金额没有统计--TODO
			// 获得收款扩展部分的金额
			// id
			$iidList = $invoice->getInvoiceByTrain ( $itidSql );
			foreach ( $iidList as $key => $value ) {
				$idData = explode ( ",", $value ['iid'] );
				$sum = 0;
				foreach ( $idData as $item ) {
					
					$sum += $invoice->getTrainRP ( $item );
				}
				//
				$itidSum [$value ['trainId']] = $sum;
			}
		}
		// print_r($iidList);
		// print_r($invoiceRecelvablesList);
		// print_r($itidSum);
		
		foreach ( $list as $key => $value ) {
			
			$countInvoice = $invoice->getInvoiceByTrainingCount ( $value ['itid'] );
			$value ['invoiceTotal'] = $countInvoice;
			$list [$key] ['invoiceTotal'] = $countInvoice;
			
			foreach ( $invoiceList as $k => $v ) {
				if ($value ['itid'] == $v ['trainId']) {
					$list [$key] ['invoiceTotalAmount'] = $v ['invoicePrice'];
					break;
				}
			}
			
			foreach ( $invoiceRecelvablesList as $i => $o ) {
				if ($value ['itid'] == $o ['trainId']) {
					$list [$key] ['invoiceArriveAmount'] = $o ['receivablesPrice'];
					$list [$key] ['arriveSchedule'] = "0";
					if ($value ['invoiceTotal'] != 0) {
						// $list [$key] ['invoiceArriveAmount']+=$itidSum[$value ['itid']];
						$list [$key] ['arriveSchedule'] = round ( $list [$key] ['invoiceArriveAmount'] / $list [$key] ['invoiceTotalAmount'] * 100, 2 );
						// $list [$key] ['arriveSchedule'] = round ( $o ['count'] / $value ['invoiceTotal'] * 100, 2 );
					}
					
					break;
				}
			}
		}
		
		return $list;
	}
}

?>